Create database [DbTesting]
GO

USE [DbTesting]
GO
/****** Object:  Table [dbo].[Orders]    Script Date: 04/06/2010 22:20:49 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Orders](
	[ID] [int] IDENTITY(1,1) NOT NULL,
	[OrderDate] [datetime] NOT NULL,
	[Customer] [nvarchar](50) NOT NULL,
 CONSTRAINT [PK_Orders_1] PRIMARY KEY NONCLUSTERED 
(
	[ID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[OrderLine]    Script Date: 04/06/2010 22:20:49 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[OrderLine](
	[OrderID] [int] NOT NULL,
	[ProductName] [nvarchar](50) NULL,
	[Count] [int] NOT NULL,
	[Price] [money] NOT NULL
) ON [PRIMARY]
GO
/****** Object:  StoredProcedure [dbo].[CreateOrderLine]    Script Date: 04/06/2010 22:20:46 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[CreateOrderLine]
	@Customer varchar(max),
	@ProductName varchar(max),
	@Count int = 1,
	@Price money = 0
AS
BEGIN TRANSACTION
	SET NOCOUNT ON;

	DECLARE @OrderID int;
	SET @OrderID = (SELECT TOP 1 ID FROM Orders WHERE Customer = @Customer ORDER BY ID DESC)
	IF @OrderID IS NULL 
	BEGIN
		INSERT INTO Orders (Customer) Values (@Customer)
		SET @OrderID = scope_identity()
	END
	
	INSERT INTO OrderLine (OrderID, ProductName, Count, Price)
		VALUES (@OrderID, @ProductName, @Count, @Price)
COMMIT TRANSACTION
GO
/****** Object:  Default [DF_OrderLine_Count]    Script Date: 04/06/2010 22:20:49 ******/
ALTER TABLE [dbo].[OrderLine] ADD  CONSTRAINT [DF_OrderLine_Count]  DEFAULT ((1)) FOR [Count]
GO
/****** Object:  Default [DF_OrderLine_Price]    Script Date: 04/06/2010 22:20:49 ******/
ALTER TABLE [dbo].[OrderLine] ADD  CONSTRAINT [DF_OrderLine_Price]  DEFAULT ((0)) FOR [Price]
GO
/****** Object:  Default [DF_Orders_OrderDate]    Script Date: 04/06/2010 22:20:49 ******/
ALTER TABLE [dbo].[Orders] ADD  CONSTRAINT [DF_Orders_OrderDate]  DEFAULT (getdate()) FOR [OrderDate]
GO
/****** Object:  Check [CK_OrderLine_Count]    Script Date: 04/06/2010 22:20:49 ******/
ALTER TABLE [dbo].[OrderLine]  WITH CHECK ADD  CONSTRAINT [CK_OrderLine_Count] CHECK  (([Count]>=(1)))
GO
ALTER TABLE [dbo].[OrderLine] CHECK CONSTRAINT [CK_OrderLine_Count]
GO
/****** Object:  ForeignKey [FK_OrderLine_Orders]    Script Date: 04/06/2010 22:20:49 ******/
ALTER TABLE [dbo].[OrderLine]  WITH CHECK ADD  CONSTRAINT [FK_OrderLine_Orders] FOREIGN KEY([OrderID])
REFERENCES [dbo].[Orders] ([ID])
GO
ALTER TABLE [dbo].[OrderLine] CHECK CONSTRAINT [FK_OrderLine_Orders]
GO
